* Program Name........: FileFix.PRG
* Purpose.............: Fix .DBF files that return the message
*                     :  'NOT A FOX DATA BASE.'
* Author..............: Les and John Pinter, Pinter Consulting Staff

SET TALK    OFF
SET SAFETY  OFF
SET MESSAGE TO 24
SET ESCAPE  OFF
SET CONFIRM OFF
SET CURSOR OFF

HelpColor = IIF ( IsColor() , "W+/RB,W+/RB,W+/RB", "W+/N,W+/N,W+/N" )

DEFINE WINDOW OKAY    FROM 18, 25 TO 21, 56 SHADOW DOUBLE
DEFINE WINDOW FixHelp FROM  5,  3 TO 23, 75 SHADOW DOUBLE COLOR &HelpColor

scolor = IIF( ISCOLOR() , [B/B,B/B]    , [N/N,N/N]  )
SET COLOR TO &SColor
CLEAR 
@ 0, 0, 21, 79 BOX REPLICATE(CHR(219),9)
scolor = IIF( ISCOLOR() , [GR+/B,W+/R] , [W+/N,N/W] )
SET COLOR TO &SColor

ON KEY LABEL F1 DO FixHelp

@  3, 58 TO 7, 78 DOUBLE
@  4, 60 SAY "Pinter Consulting"
@  5, 60 SAY "File Fix Utility"
@  6, 60 SAY "    F1 - Help"
@ 22, 0 TO 22, 79
@ 23, 0 SAY " ** Building File List **"

DIMENSION filelist(128)
PUBLIC linecount, onscreen

DO LoadList

DO WHILE .T.
   
   @ 23,     0 CLEAR 
   @ 23,     0 PROMPT " View Directory " MESSAGE " Display current DBF files and status"
   @ 23, COL() PROMPT " Fix a File "     MESSAGE " Fix a trashed .DBF file"
   @ 23, COL() PROMPT " Exit "           MESSAGE " Exit to DOS"
   choice = 1
   MENU TO choice
   @ 23,     0 CLEAR 
   
   choice = IIF( choice = 0 , [ ] , SUBSTR( [VF ] , choice , 1 ) )
   
   DO CASE 
      
   CASE choice = [ ]
      
      EXIT 
      
   CASE choice = [V]
      
      @ 23, 0 SAY [  PgUp/PgDn to scroll list, ESC for MENU]
      @ 3, 3 MENU filelist, linecount, onscreen SHADOW
      choice = 1
      READ MENU TO choice
      
   CASE choice = [F]
      
      DO WHILE .T.
         
         @ 23, 0 SAY [  PgUp/PgDn to scroll list, RETURN to select, ESC to cancel]
         @ 3, 3 MENU filelist, linecount, onscreen SHADOW
         choice = 1
         READ MENU TO choice
         
         filename = IIF( choice = 0 , " " , filelist ( choice ) )
         
         IF LEN(TRIM(filename)) = 0
            EXIT 
         ENDIF 
         
         IF .NOT. [DBF] $ filename ;
            WAIT WINDOW ;
            "Please highlight a file name and press ENTER, or press ESCAPE to exit"
            LOOP 
         ENDIF 
         
         IF .NOT. [NOT A FOX] $ UPPER( filename )
            filename = ALLTRIM ( LEFT( filename , 13 ) )
            WAIT WINDOW filename + " doesn't need fixing" TIMEOUT 1
            LOOP 
         ENDIF 
         
         filename = ALLTRIM ( LEFT( filename , 13 ) )
         oldname = LEFT(filename,AT(".",filename)-1) + ".OLD"

         IF FILE(oldname)
            IF .NOT. OK2GO_ON()
               LOOP
            ENDIF
         ENDIF

         readfile  = FOPEN(filename)
         writefile = FCREATE("FIXED")
         
         * Set up status window
         SAVE SCREEN 
         @  9,19,16,60 BOX "Ŀ "
         @ 11,19 SAY "Ĵ"
         @ 10,21 SAY "File :"
         @ 12,26 SAY "Number of Fields  :"
         @ 13,26 SAY "Record Length     :"
         @ 14,26 SAY "Number of Records :"
         @ 10,28 SAY filename
         @ 15,20 SAY REPLICATE("",40)
         
         * Determine actual number of records
         = FREAD ( readfile , 10 )
         reclen    = ASC( FREAD ( readfile , 1) )
         reclen    = reclen + ASC( FREAD ( readfile , 1) )
         @ 13,46 SAY ALLTRIM(STR(reclen))
         = FREAD ( readfile , 20 )
         sentinel  = ASC( FREAD ( readfile , 1) )
         numfields = 0
         DO WHILE sentinel <> 13
            numfields = numfields + 1
            = FREAD ( readfile , 31)
            sentinel  = ASC( FREAD ( readfile,  1 ) )
         ENDDO 
         filelen = fseek(readfile, 0, 2)
         numrecs = ( filelen - ( 32 * numfields ) - 34 ) / reclen
         @ 12,46 SAY ALLTRIM ( STR( numfields ) )
         @ 14,46 SAY ALLTRIM ( STR( INT( numrecs ) ) )
         =fseek ( readfile , 0 , 0 )
         
         * Build fixed file
         =FWRITE(writefile, FREAD(readfile, 4))
         =FREAD(readfile, 2)
         =FWRITE(writefile, CHR(MOD(numrecs,256)))
         =FWRITE(writefile, CHR(INT(numrecs/256)))
         =FWRITE(writefile, FREAD(readfile, 4))
         =FREAD(readfile, 2)
         =FWRITE(writefile, CHR(MOD(reclen,256)))
         =FWRITE(writefile, CHR(INT(reclen/256)))
         =FWRITE(writefile, FREAD(readfile, (numfields*32)+21))

         numrecs  = INT ( numrecs )   && Bug fix for comparing INT to REAL
         FOR LOOP = 1 TO numrecs
            @ 15,20 SAY REPLICATE("",(LOOP /numrecs)*40)
            =FWRITE(writefile, FREAD(readfile, reclen))
         ENDFOR
         =FWRITE(writefile, CHR(26))
         
         =fclose(writefile)
         =fclose(readfile)
         
         oldname = LEFT(filename,AT(".",filename)-1) + ".OLD"
         RENAME &filename TO &OldName
         RENAME FIXED.    TO &FileName
         
         RESTORE SCREEN 

         DO LoadList

      ENDDO 
      
   ENDCASE 
   
ENDDO 

CLEAR 
@ 24, 0 SAY " ** Be sure to back up your data files regularly **"

CLOSE ALL 
RELEASE WINDOW OKAY
SET CURSOR ON

QUIT



PROCEDURE LoadList

* -- Build an array consisting of the .DBF display produced by the
* -- FoxPro DIR command, so that the trashed file display can be
* -- viewed by the user.

SET CONSOLE OFF 
SET ALTERNATE TO FILES
SET ALTERNATE ON 
DIR 
SET ALTERNATE TO 
SET CONSOLE ON 

fh = FOPEN ( 'FILES.TXT' )
FOR i = 1 TO 128
   filelist ( i ) = [ ] + LEFT( FGETS ( fh ) , 43 )
   IF ( LEN( ALLTRIM ( filelist ( i ) ) ) = 0 .AND. i > 2 );
      .OR. ( i = 127 )
      EXIT
   ENDIF
   IF 'NOT A FOX' $ UPPER ( filelist ( i ) )   && Drop trailing characters...
      filelist ( i ) = LEFT ( filelist ( i ) , 40 ) + SPACE(3)
   ENDIF
ENDFOR

=FCLOSE(fh)

linecount = i - 1
onscreen  = IIF( linecount <= 17 , linecount , 17 )

filelist ( 1 ) = filelist ( 2 )
filelist ( 2 ) = REPLICATE( [] , 44 )

@ 3, 3, 3+linecount+1,3+45 BOX [ͻȺ ]
FOR i = 1 TO linecount
   @ 3+i,4 SAY filelist(i)
ENDFOR

RETURN 



PROCEDURE Ok2Go_On

ACTIVATE WINDOW OKAY

CLEAR
@ 0,       1 SAY "File " + OldName + " already exists."
@ 1,       5 PROMPT " Cancel "
@ 1, COL()+1 PROMPT " Proceed "
choice = 1
MENU TO choice

DEACTIVATE WINDOW OKAY

IF choice <> 2
   RETURN .F.
 ELSE
   DELETE FILE &OldName
   RETURN .T.
ENDIF



PROCEDURE FixHelp

ACTIVATE WINDOW FixHelp
CLEAR
TEXT
                   Pinter FoxPro Letter File Fixer
                   
     This program will restore access to files that FoxPro has marked
  'not a Fox data base'.  It works in the same way that the Norton
  Utilities(tm) FileFix program works.

     If FoxPro reports that a file is 'Not a Fox data base', run this
  program and pick the file in question from the file list. The data
  will be copied to a new file first. Then, your original file will
  be renamed to <filename>.OLD, and the fixed file will be renamed
  to the production file name.

     If you've already got a file named <filename>.OLD, the program
  won't proceed unless you tell it to delete the file. If you want to
  SAVE your .OLD file, rename it to something else, then run FileFix.
  
      PO Box 1324    Menlo Park, CA 94026-1324    (415) 325-7953
EndText
WAIT WINDOW

DEACTIVATE WINDOW FixHelp

RETURN
